% fig17_5_1.pl
% P421P422܂17.3plang̃vOB
% 17_2Ƃ̍́BconcBƓII
% plan( [ clear(2), clear(4), clear(b), clear(c), on(a,1), on(b,3), on(c,a) ], [on( a, b)], Plan, FinState).
% 
% Plan = [move(c, a, 2), move(a, 1, b)]
% FinState = [on(a, b), clear(1), on(c, 2), clear(a), clear(4), clear(c), on(b, 3)] 
% 
% plan( [ clear(2), clear(4), clear(b), clear(c), on(a,1), on(b,3), on(c,a) ], [on( a, b), on( b, c)], Plan, _).
% 
% Plan = [move(b, 3, c), move(b, c, 3), move(c, a, 2), move(a, 1, b), move(a, b, 1), move(b, 3, c), move(a, 1, b)] 
% 
% plan( [ clear(2), clear(4), clear(b), clear(c), on(a,1), on(b,3), on(c,a) ], [clear(2), clear(3)], Plan, _).
% 
% ERROR: Out of local stack
%   Exception: (1,801) plan([on(b, 3), clear(2), clear(4), clear(b), clear(c), on(a, 1), on(c, a)], [clear(2), clear(3)], _G122893, _G63) ? creep

% conc͕ʂ̂Ƃ납
conc([], L, L).

conc([X|L1],L2, [X|L3]) :-
  conc(L1,L2,L3).


%  Figure 17.2  A definition of the planning space for the blocks world.
%  Note: For compatibility with Sicstus Prolog, predicate block/1 in Figure 17.2
%  is here replaced by is_block/1.

% Definition of action move( Block, From, To) in blocks world

% can( Action, Condition): Action possible if Condition true

can( move( Block, From, To), [ clear( Block), clear( To), on( Block, From)] ) :-
  is_block( Block),      % Block to be moved
  object( To),           % "To" is a block or a place
  To \== Block,          % Block cannot bEmoved to itself
  object( From),         % "From" is a block or a place
  From \== To,           % Move to new position
  Block \== From.        % Block not moved from itself

% adds( Action, Relationships): Action establishes Relationships

adds( move(X,From,To), [ on(X,To), clear(From)]).

% deletes( Action, Relationships): Action destroys Relationships

deletes( move(X,From,To), [ on(X,From), clear(To)]).

object( X)  :-           % X is an objects if
  place( X)              % X is a place
  ;                      % or
  is_block( X).          % X is a block


% A blocks world

is_block( a).
is_block( b).
is_block( c).

place( 1).
place( 2).
place( 3).
place( 4).

%  A state in the blocks world
%
%         c
%         a b
%         ====
%  place  1234

state1([ clear(2), clear(4), clear(b), clear(c), on(a,1), on(b,3), on(c,a) ] ).

%   Figure 17.5  A simple means-ends planner.

%   A simple means-ends planner
%   plan( State, Goals, Plan, FinalState)

plan( State, Goals, [], State)  :-                 % Plan is empty
  satisfied( State, Goals).                        % Goals true in State

%  The way plan is decomposed into stages by conc, the 
%  precondition plan (PrePlan) is found in breadth-first
%  fashion. However, the length of the rest of plan is not 
%  restricted and goals are achieved in depth-first style.

plan( State, Goals, Plan, FinalState)  :-
  conc( PrePlan, [Action | PostPlan], Plan),        % Divide plan
  select( State, Goals, Goal),                      % Select a goal
  achieves( Action, Goal),                          % Relevant action
  can( Action, Condition),
  plan( State, Condition, PrePlan, MidState1),      % Enable Action
  apply( MidState1, Action, MidState2),             % Apply Action
  plan( MidState2, Goals, PostPlan, FinalState).    % Achieve remaining goals

% satisfied( State, Goals): Goals are true in State

satisfied( State, []).

satisfied( State, [Goal | Goals])  :-
  member( Goal, State),
  satisfied( State, Goals).

select( State, Goals, Goal)  :-
  member( Goal, Goals),
  \+ member( Goal, State).                % Goal not satisfied already

% not member( Goal, State).
% not͑gݍ݊֐Ȃ̂ŎgȂ
% achieves( Action, Goal): Goal is add-list of Action

achieves( Action, Goal)  :-
  adds( Action, Goals),
  member( Goal, Goals).

% apply( State, Action, NewState): Action executed in State produces NewState

apply( State, Action, NewState)  :-
  deletes( Action, DelList),
  delete_all( State, DelList, State1), !,
  adds( Action, AddList),
  conc( AddList, State1, NewState).

%  delete_all( L1, L2, Diff) if Diff is set-difference of L1 and L2

delete_all( [], _, []).

delete_all( [X | L1], L2, Diff)  :-
  member( X, L2),  !,
  delete_all( L1, L2, Diff).

delete_all( [X | L1], L2, [X | Diff])  :-
  delete_all( L1, L2, Diff).

